## Script (Python) "ping"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=REQUEST
##title=
##
SUCCESS = """<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>0</error>
</response>"""

ERROR = """<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>1</error>
<message>error</message>
</response>"""

def getTarget():
    if getattr(context, 'isPrincipiaFolderish', 0)==1:
        target = context.index_html
    else:
        target = context
    return target

if REQUEST.REQUEST_METHOD=='POST':
    if REQUEST.get_header('CONTENT_TYPE')!='application/x-www-form-urlencoded':
        return ERROR
    try:
        form = REQUEST.form

        title = form['title']
        excerpt = form['excerpt']
        url = form['url']
        blog_name = form['blog_name']
        site_charset = context.portal_properties.site_properties.default_charset

        target = getTarget()
        trackback = context.portal_trackback.getTrackbackFor(target)
        trackback.addPing(title, excerpt, url, blog_name, site_charset)
        return SUCCESS
    except Exception, e:
        return ERROR

else:
   return ERROR
